package com.hai.dao;

import com.hai.entity.SecRole;
import com.hai.entity.SecRoleExample;
import com.hai.entity.SecRoleExample.Criteria;
import com.hai.entity.SecRoleExample.Criterion;
import org.apache.ibatis.jdbc.SQL;

import java.util.List;
import java.util.Map;

public class SecRoleSqlProvider {

    public String countByExample(SecRoleExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("sec_role");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(SecRoleExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("sec_role");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(SecRole record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("sec_role");
        
        if (record.getRoleName() != null) {
            sql.VALUES("role_name", "#{roleName,jdbcType=VARCHAR}");
        }
        
        if (record.getRoleDesc() != null) {
            sql.VALUES("role_desc", "#{roleDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getRoleType() != null) {
            sql.VALUES("role_type", "#{roleType,jdbcType=INTEGER}");
        }
        
        if (record.getEnableStatus() != null) {
            sql.VALUES("enable_status", "#{enableStatus,jdbcType=INTEGER}");
        }
        
        if (record.getPrimaryRole() != null) {
            sql.VALUES("primary_role", "#{primaryRole,jdbcType=INTEGER}");
        }
        
        if (record.getTempletType() != null) {
            sql.VALUES("templet_type", "#{templetType,jdbcType=INTEGER}");
        }
        
        if (record.getCompanyId() != null) {
            sql.VALUES("company_id", "#{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getTempRoleId() != null) {
            sql.VALUES("temp_role_id", "#{tempRoleId,jdbcType=BIGINT}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        return sql.toString();
    }

    public String selectByExample(SecRoleExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("role_name");
        sql.SELECT("role_desc");
        sql.SELECT("role_type");
        sql.SELECT("enable_status");
        sql.SELECT("primary_role");
        sql.SELECT("templet_type");
        sql.SELECT("company_id");
        sql.SELECT("temp_role_id");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.FROM("sec_role");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        SecRole record = (SecRole) parameter.get("record");
        SecRoleExample example = (SecRoleExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("sec_role");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getRoleName() != null) {
            sql.SET("role_name = #{record.roleName,jdbcType=VARCHAR}");
        }
        
        if (record.getRoleDesc() != null) {
            sql.SET("role_desc = #{record.roleDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getRoleType() != null) {
            sql.SET("role_type = #{record.roleType,jdbcType=INTEGER}");
        }
        
        if (record.getEnableStatus() != null) {
            sql.SET("enable_status = #{record.enableStatus,jdbcType=INTEGER}");
        }
        
        if (record.getPrimaryRole() != null) {
            sql.SET("primary_role = #{record.primaryRole,jdbcType=INTEGER}");
        }
        
        if (record.getTempletType() != null) {
            sql.SET("templet_type = #{record.templetType,jdbcType=INTEGER}");
        }
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        }
        
        if (record.getTempRoleId() != null) {
            sql.SET("temp_role_id = #{record.tempRoleId,jdbcType=BIGINT}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("sec_role");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("role_name = #{record.roleName,jdbcType=VARCHAR}");
        sql.SET("role_desc = #{record.roleDesc,jdbcType=VARCHAR}");
        sql.SET("role_type = #{record.roleType,jdbcType=INTEGER}");
        sql.SET("enable_status = #{record.enableStatus,jdbcType=INTEGER}");
        sql.SET("primary_role = #{record.primaryRole,jdbcType=INTEGER}");
        sql.SET("templet_type = #{record.templetType,jdbcType=INTEGER}");
        sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        sql.SET("temp_role_id = #{record.tempRoleId,jdbcType=BIGINT}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        
        SecRoleExample example = (SecRoleExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(SecRole record) {
        SQL sql = new SQL();
        sql.UPDATE("sec_role");
        
        if (record.getRoleName() != null) {
            sql.SET("role_name = #{roleName,jdbcType=VARCHAR}");
        }
        
        if (record.getRoleDesc() != null) {
            sql.SET("role_desc = #{roleDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getRoleType() != null) {
            sql.SET("role_type = #{roleType,jdbcType=INTEGER}");
        }
        
        if (record.getEnableStatus() != null) {
            sql.SET("enable_status = #{enableStatus,jdbcType=INTEGER}");
        }
        
        if (record.getPrimaryRole() != null) {
            sql.SET("primary_role = #{primaryRole,jdbcType=INTEGER}");
        }
        
        if (record.getTempletType() != null) {
            sql.SET("templet_type = #{templetType,jdbcType=INTEGER}");
        }
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getTempRoleId() != null) {
            sql.SET("temp_role_id = #{tempRoleId,jdbcType=BIGINT}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, SecRoleExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}
